# RadeonRays 4.1

## Summary

RadeonRays is a ray intersection acceleration library. AMD developed RadeonRays to help developers make the most of GPU and to eliminate the need to maintain hardware-dependent code.

The library offers a well-defined C API for scene building and performing asynchronous ray intersection queries.

RadeonRays is not limited to AMD hardware, a specific operating system or graphics framework. The library helps assure compatibility and best performance across a wide range of hardware platforms.

## Backends

The library supports the following graphics and GPGPU frameworks as its backends:

- DirectX12
- Vulkan

## System Requirements

RadeonRays requires a PC with the following software and hardware:

- DirectX12: a 64-bit version of Windows&reg; 10, and a GPU and drivers that supports DirectX12 features
- Vulkan: a 64-bit version of Windows&reg; 10 or Linux, and a GPU and drivers that support Vulkan version 1.2
- Installed spdlog library

## Documentation

[Documentation page](https://radeon-pro.github.io/RadeonProRenderDocs/en/rr/about.html)
